// Ejemplo FreeImage 8
// Conversin de mapas de bits
// Abril 2023, Salvador Pozo, Con Clase

#include <iostream>
#include <Freeimage.h>

const char *TipoImagen(FREE_IMAGE_TYPE tipo);

int main(int argc, char**argv)
{
    FIBITMAP* dib;
    FIBITMAP* dib2;
	char *lpszPathName;
    FREE_IMAGE_FORMAT fif = FIF_UNKNOWN;

	if(argc < 2) {
        printf("Usar: FreeImage008 <fichero>\n");
        return 0;
	}
	lpszPathName = argv[1];

	fif = FreeImage_GetFileType(lpszPathName, 0);
	if(fif == FIF_UNKNOWN) {
		fif = FreeImage_GetFIFFromFilename(lpszPathName);
	}
	if((fif != FIF_UNKNOWN) && FreeImage_FIFSupportsReading(fif)) {
		dib = FreeImage_Load(fif, lpszPathName, 0);
		std::cout << "Fichero: " << lpszPathName << std::endl;

		if(FreeImage_HasPixels(dib)) {
            RGBQUAD bkcolor = {64,96,64,0};
            dib2 = FreeImage_Rotate(dib, 45, &bkcolor);
            FreeImage_Save(FIF_JPEG, dib2, "rotado1.jpg", JPEG_DEFAULT);
            FreeImage_Unload(dib2);
            double x_orig = 93;
            double y_orig = 112;
            dib2 = FreeImage_RotateEx(dib, 10, 0, 0, x_orig, y_orig, FALSE);
            FreeImage_Save(FIF_JPEG, dib2, "rotado2.jpg", JPEG_DEFAULT);
            FreeImage_Unload(dib2);
            FreeImage_FlipHorizontal(dib);
            FreeImage_Save(FIF_JPEG, dib, "volteo_h.jpg", JPEG_DEFAULT);
            FreeImage_FlipVertical(dib);
            FreeImage_Save(FIF_JPEG, dib, "volteo_v.jpg", JPEG_DEFAULT);
            FreeImage_FlipHorizontal(dib);
            FreeImage_FlipVertical(dib);
            dib2 = FreeImage_Rescale(dib, FreeImage_GetWidth(dib)*10, FreeImage_GetHeight(dib)*10, FILTER_BOX);
            FreeImage_Save(FIF_JPEG, dib2, "reescala_box.jpg", JPEG_DEFAULT);
            FreeImage_Unload(dib2);
            dib2 = FreeImage_Rescale(dib, FreeImage_GetWidth(dib)*10, FreeImage_GetHeight(dib)*10, FILTER_BILINEAR);
            FreeImage_Save(FIF_JPEG, dib2, "reescala_bilinear.jpg", JPEG_DEFAULT);
            FreeImage_Unload(dib2);
            dib2 = FreeImage_Rescale(dib, FreeImage_GetWidth(dib)*10, FreeImage_GetHeight(dib)*10, FILTER_BSPLINE);
            FreeImage_Save(FIF_JPEG, dib2, "reescala_bspline.jpg", JPEG_DEFAULT);
            FreeImage_Unload(dib2);
            dib2 = FreeImage_Rescale(dib, FreeImage_GetWidth(dib)*10, FreeImage_GetHeight(dib)*10, FILTER_BICUBIC);
            FreeImage_Save(FIF_JPEG, dib2, "reescala_bicubic.jpg", JPEG_DEFAULT);
            FreeImage_Unload(dib2);
            dib2 = FreeImage_Rescale(dib, FreeImage_GetWidth(dib)*10, FreeImage_GetHeight(dib)*10, FILTER_CATMULLROM);
            FreeImage_Save(FIF_JPEG, dib2, "reescala_catmullrom.jpg", JPEG_DEFAULT);
            FreeImage_Unload(dib2);
            dib2 = FreeImage_Rescale(dib, FreeImage_GetWidth(dib)*10, FreeImage_GetHeight(dib)*10, FILTER_LANCZOS3);
            FreeImage_Save(FIF_JPEG, dib2, "reescala_lanczos3.jpg", JPEG_DEFAULT);
            FreeImage_Unload(dib2);
            dib2 = FreeImage_RescaleRect(dib, 256, 256, 76, 89, 25, 25, FILTER_BOX, FI_RESCALE_DEFAULT);
            FreeImage_Save(FIF_JPEG, dib2, "reescala_rec.jpg", JPEG_DEFAULT);
            FreeImage_Unload(dib2);
            dib2 = FreeImage_MakeThumbnail(dib, 64, TRUE);
            FreeImage_Save(FIF_JPEG, dib2, "thumbnail.jpg", JPEG_DEFAULT);
            FreeImage_Unload(dib2);
		}
    }
	FreeImage_Unload(dib);

    return 0;
}
